/***************************************************************************
                          optionsdialog.h  -  description
                             -------------------
    begin                : Thu Mar 30 2000
    copyright            : (C) 2000 by Alexander Theel
    email                : alex.theel@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPTIONSDIALOG_H
#define OPTIONSDIALOG_H

#include "IOptionsDialog.h"
//#include <qtabdialog.h>
#include <qtabbar.h>

#include <qhbox.h>
#include <qvbox.h>
#include <qgrid.h>
#include <qcheckbox.h>

#include <qlabel.h>
#include <qlineedit.h>
#include <qvalidator.h>

#include <qpushbutton.h>
#include <qcolordialog.h>
#include <qstring.h>
#include <qfont.h>

#include "../../../CTuxCardsConfiguration.h"

#include <iostream>
class OptionsDialog : public IOptionsDialog {
   Q_OBJECT
public:
   OptionsDialog(QWidget* parent, CTuxCardsConfiguration& config);
   int setUp( void );

   bool getAutosave();
   int  getMinutes();
   bool getSaveWhenLeaving();
   bool getCreateBackup();

   QColor  getTopColor();
   QColor  getBottomColor();
   QColor  getBarTextColor();
   bool    getEnableHText();
   QString getTextOne();
   QString getTextTwo();

   bool    getEnableVText();
   QString getVerticalText();
   bool    getAlignVText();

   bool    getEnableCactusBar();
   QString getFlowerDir();

   QFont   getTreeFont();
   QFont   getEditorFont();
   int     getTabSize();
   int     getWordWrap();

protected slots:
   virtual void changeTopColor();
   virtual void changeBottomColor();
   virtual void changeTextColor();

   virtual void changeTreeFont();
   virtual void changeEditFont();
   virtual void chooseFlowerDir();

   virtual void changeProperties();

// virtual void setDefaults();

signals:
  void configurationChanged();

private:
  CTuxCardsConfiguration& mrefConfig;
};

#endif

