TEMPLATE = app #lib
CONFIG =  qt warn_on release #debug #release  #staticlib

exists( $(QTDIR)/lib/libqt-mt* ) {
   message( "Configuring for multi-threaded Qt..." )
   CONFIG += thread
}

TARGET = tuxcards


OBJECTS_DIR = ./output/bin
MOC_DIR     = ./output/moc

HEADERS = src/gui/cactusbar/cactus.h \
          src/information/informationformat.h \
          src/information/CInformationElement.h \
          src/information/CTreeInformationElement.h \
          src/information/CInformationCollection.h \
          src/information/CInformationElementHistory.h \
          src/information/IHistoryListener.h \
          src/information/converter.h \
          src/information/Path.h \
          src/information/htmlwriter.h \
          src/information/xmlpersister.h \
          src/information/IRemoveElementListener.h \
          src/information/IView.h \
          src/information/IParent.h \
          src/gui/bookmark/BookmarkButton.h \
          src/gui/cactusbar/CCactusBar.h \
          src/gui/cactusbar/cactusshoot.h \
          src/gui/cactusbar/cactustools.h \
          src/gui/cactusbar/imagemanager.h \
          src/gui/colorbar/CColorBar.h \
          src/gui/editor/CSingleEntryView.h \
          src/gui/editor/CEncryptedEntryView.h \
          src/gui/editor/editor.h \
          src/gui/recentFileList/RecentFileList.h \
          src/gui/dialogs/expiredElementsDialog/ExpiredElementsDialog.h \
          src/gui/dialogs/iconselectordialog/iconselector.h \
          src/gui/dialogs/iconselectordialog/iconselectordialog.h \
          src/gui/dialogs/optionsDialog/optionsdialog.h \
          src/gui/dialogs/propertyDialog/CPropertyDialog.h \
          src/gui/dialogs/searchDialog/searchdialog.h \
          src/gui/dialogs/searchDialog/searchlistitem.h \
          src/gui/dialogs/searchDialog/searchposition.h \
          src/gui/dialogs/passwdDialog/CPasswdDialog.h \
          src/gui/mainwindow.h \
          src/gui/CTree.h \
          src/gui/CTreeElement.h \
          src/utilities/crypt/BlowFish.h \
          src/utilities/crypt/BlowFish2.h \
          src/utilities/crypt/MD5.h \
          src/utilities/crypt/StringCrypter.h \
          src/utilities/base64/CBase64Coder.h \
          src/utilities/iniparser/configgroup.h \
          src/utilities/iniparser/configparser.h \
          src/utilities/strings.h \
          src/utilities/integers.h \
          src/utilities/CIconManager.h \
          src/persister.h \
          src/CTuxCardsConfiguration.h \
          src/fontsettings.h \
          src/commandlineoptions.h \
          src/version.h \
          src/global.h


SOURCES = src/gui/cactusbar/cactus.cpp \
         src/information/informationformat.cpp \
         src/information/CInformationElement.cpp \
         src/information/CTreeInformationElement.cpp \
         src/information/CInformationCollection.cpp \
         src/information/CInformationElementHistory.cpp \
         src/information/converter.cpp \
         src/information/Path.cpp \
         src/information/htmlwriter.cpp \
         src/information/xmlpersister.cpp \
         src/gui/bookmark/BookmarkButton.cpp \
         src/gui/cactusbar/CCactusBar.cpp \
         src/gui/cactusbar/cactusshoot.cpp \
         src/gui/cactusbar/cactustools.cpp \
         src/gui/cactusbar/imagemanager.cpp \
         src/gui/colorbar/CColorBar.cpp \
         src/gui/editor/CSingleEntryView.cpp \
         src/gui/editor/CEncryptedEntryView.cpp \
         src/gui/editor/editor.cpp \
         src/gui/recentFileList/RecentFileList.cpp \
         src/gui/dialogs/expiredElementsDialog/ExpiredElementsDialog.cpp \
         src/gui/dialogs/iconselectordialog/iconselector.cpp \
         src/gui/dialogs/iconselectordialog/iconselectordialog.cpp \
         src/gui/dialogs/optionsDialog/optionsdialog.cpp \
         src/gui/dialogs/propertyDialog/CPropertyDialog.cpp \
         src/gui/dialogs/searchDialog/searchdialog.cpp \
         src/gui/dialogs/searchDialog/searchlistitem.cpp \
         src/gui/dialogs/searchDialog/searchposition.cpp \
         src/gui/dialogs/passwdDialog/CPasswdDialog.cpp \
         src/gui/mainwindow.cpp \
         src/gui/CTree.cpp \
         src/gui/CTreeElement.cpp \
         src/utilities/crypt/BlowFish.cpp \
         src/utilities/crypt/MD5.cpp \
         src/utilities/crypt/StringCrypter.cpp \
         src/utilities/base64/CBase64Coder.cpp \
         src/utilities/iniparser/configgroup.cpp \
         src/utilities/iniparser/configparser.cpp \
         src/utilities/strings.cpp \
         src/utilities/integers.cpp \
         src/utilities/CIconManager.cpp \
         src/main.cpp \
         src/persister.cpp \
         src/CTuxCardsConfiguration.cpp \
         src/fontsettings.cpp \
         src/commandlineoptions.cpp

FORMS  =       src/gui/dialogs/expiredElementsDialog/ExpiredElementsDialogInterface.ui \
               src/gui/dialogs/propertyDialog/IPropertyDialog.ui \
               src/gui/dialogs/optionsDialog/IOptionsDialog.ui \
               src/gui/dialogs/passwdDialog/IPasswdDialog.ui

target.path = /usr/local/bin/
INSTALLS += target


documentation.path  = /usr/local/doc/tuxcards/
documentation.files = docs/*
documentation.files = src/gui/cactusbar/flowers/
INSTALLS += documentation

